package tictactoe;

import tictactoe.gui.GUIplayer;

/**
 * Abstract superclass of TicTacToeFactory and GomokuFactory
 * @author $Author: oscar $
 * @version $Id: GameFactory.java 16531 2008-02-28 15:58:20Z oscar $
 */
public abstract class GameFactory {
	protected BoardGame game_ = null;

	/**
	 * @return a game with GUIplayers bound.
	 */
	public BoardGame getGame() {
		BoardGame game;
		if (game_ == null) {
			Player X = new GUIplayer('X');
			Player O = new GUIplayer('O');
			game_ = makeGame(X,O);
			game = game_;
		} else {
			game = game_;
			game_ = null;
		}
		return game;
	}
	
	/**
	 * Subclasses implement the actual factory method.
	 */
	protected abstract BoardGame makeGame(Player X, Player O);
}
